#****************************************************************************
#**
#**  File     :  /cdimage/lua/modules/weapon.lua
#**  Author(s):  John Comes
#**
#**  Summary  : The base weapon class for all weapons in the game.
#**
#**  Copyright  2005 Gas Powered Games, Inc.  All rights reserved.
#****************************************************************************

local oldWeapon = Weapon

Weapon = Class(oldWeapon) {

	ParseEntityCategoryEx = function(cat)
		local cat = string.gsub(cat, ' ', '+')
	    local result = string.gsub(cat, "(%u+)", "categories.%1") 
	    if not string.find(result, 'categories') then
	    	local f = 'Failed to parse'
	    	return f
	    else
	    	local f = loadstring("return " .. result) 
	    	return f()
	    end
	end,
	
    SetWeaponPriorities = function(self, priTable)
        if not priTable then
            local bp = self:GetBlueprint().TargetPriorities
            if bp then
                local priorityTable = {}
                if not self.OriginalPriorityTable then
                	self.OriginalPriorityTable = table.copy(bp)
                end
                self.PriorityTable = self.OriginalPriorityTable
                self.PriorityTableToInsertTo = self.OriginalPriorityTable
                for k, v in bp do
                    table.insert(priorityTable, ParseEntityCategory(v))
                end
                self:SetTargetingPriorities(priorityTable)
            end
        else
            self:SetTargetingPriorities(priTable)
        end
    end,
    
    SetModWeaponPriorities = function(self, priTable,Clear,WeaponType)
    	--LOG('bp ', repr(self:GetBlueprint().TargetPriorities))
        if not priTable then
            local bp = self:GetBlueprint().TargetPriorities
            if bp then
                if not self.OriginalPriorityTable then
                	self.OriginalPriorityTable = table.copy(bp)
                end
                local priorityTable = {}
                self.PriorityTable = self.OriginalPriorityTable
                self.PriorityTableToInsertTo = self.OriginalPriorityTable
                for k, v in bp do
                    table.insert(priorityTable, ParseEntityCategory(v))
                end
                self:SetTargetingPriorities(priorityTable)
                #local aiBrain = self.unit:GetAIBrain()
                #local UnitID = self.unit:GetUnitId()
            end
        else
        	if Clear then
        		self.PriorityTableToInsertTo = table.copy(priTable)
        	end
	        if not Clear then
	        	local oldpriority = table.copy(priTable)
	        	priTable = table.copy(self.PriorityTableToInsertTo)
	        	for k, v in oldpriority do
	        	--	LOG('Adding ; ', v , ' at ', k)
	        		local pri = string.gsub(v, ' ', '+')
	        		table.insert(priTable,k,pri )
	        	end
	        	--LOG('oldPriTable ',repr(priTable))
	        end
	        self.PriorityTable = priTable
	        LOG(repr(priTable))
			local priorityTable = {}
	        for k, v in priTable do
	        	local parsedcat = self.ParseEntityCategoryEx(v)
	        	if parsedcat == 'Failed to parse' then
	        		WARN(parsedcat)
	        	else
	        		table.insert(priorityTable, self.ParseEntityCategoryEx(v))
	        	end
	        end
	        --LOG(table.getn(priTable))
	        --LOG('Setting targets ', Clear)
	        if table.getn(priorityTable) ~= 0 then
				self:SetTargetingPriorities(priorityTable)
			end
	            #local aiBrain = self.unit:GetAIBrain()
	            #local UnitID = self.unit:GetUnitId()
# 	        end
		end
    end,
    

}

