####################################
##	Priority Window functions ##
##	By Neruz ##
####################################

local Bitmap = import('/lua/maui/bitmap.lua').Bitmap
local LayoutHelpers = import('/lua/maui/layouthelpers.lua')
local UIUtil = import('/lua/ui/uiutil.lua')
local Button = import('/lua/maui/button.lua').Button
local Edit = import('/lua/maui/edit.lua').Edit
local Group = import('/lua/maui/group.lua').Group
local Control = import('/lua/maui/control.lua').Control
local EffectHelpers = import('/lua/maui/effecthelpers.lua')
local ItemList = import('/lua/maui/itemlist.lua').ItemList
local Border = import('/lua/maui/border.lua').Border
local pathuiimg='/mods/TargetPriorityChanger/textures'
local Group = import('/lua/maui/group.lua').Group
local Prefs = import('/lua/user/prefs.lua')
local CM = import('/lua/ui/game/commandmode.lua')
local Orders = import('/lua/ui/game/orders.lua')
local USC = import('/lua/user/UserScriptCommand.lua')
local GM = import('/lua/ui/game/gamemain.lua')
local SaveList = false

function CreateMainGroup()
	mapGroup = import('/lua/ui/game/borders.lua').GetMapGroup()

	parentGroup = Group(GetFrame(0), "PriorityChangerDialogGroup")
	LayoutHelpers.AtCenterIn(parentGroup, mapGroup)
	parentGroup.Depth:Set(GetFrame(0):GetTopmostDepth() + 1)
	
	EditBackground = Bitmap(parentGroup, '/mods/TargetPriorityChanger/textures/background.dds')
	LayoutHelpers.AtCenterIn(EditBackground, parentGroup) 
	EditBackground.Width:Set(380)
	EditBackground.Height:Set(400)
	parentGroup.Width:Set(EditBackground.Width)
	parentGroup.Height:Set(EditBackground.Height)


	EditBrackets = Bitmap(parentGroup, '/mods/TargetPriorityChanger/textures/backgroundbrackets.dds')
	EditBrackets.Depth:Set(function() return parentGroup.Depth() + 3 end)
	LayoutHelpers.AtCenterIn(EditBrackets, EditBackground)   
	EditBrackets.Width:Set(380)
	EditBrackets.Height:Set(400)
    
	CreateSaveButtons(EditBackground)
	PrioritiesBackground = Bitmap(parentGroup, '/mods/TargetPriorityChanger/textures/background.dds')
	LayoutHelpers.AtCenterIn(PrioritiesBackground, parentGroup) 
	PrioritiesBackground.Width:Set(400)
	PrioritiesBackground.Height:Set(430)
	parentGroup.Width:Set(PrioritiesBackground.Width)
	parentGroup.Height:Set(PrioritiesBackground.Height)


	PrioritiesBrackets = Bitmap(parentGroup, '/mods/TargetPriorityChanger/textures/backgroundbrackets.dds')
	PrioritiesBrackets.Depth:Set(function() return parentGroup.Depth() + 4 end)
	LayoutHelpers.AtCenterIn(PrioritiesBrackets, PrioritiesBackground)   
	PrioritiesBrackets.Width:Set(400)
	PrioritiesBrackets.Height:Set(430)
	
	ConfirmationBackground = Bitmap(parentGroup, '/mods/TargetPriorityChanger/textures/background.dds')
	LayoutHelpers.AtCenterIn(ConfirmationBackground, parentGroup) 
	ConfirmationBackground.Depth:Set(function() return parentGroup.Depth() + 20 end)
	ConfirmationBackground.Width:Set(200)
	ConfirmationBackground.Height:Set(80)
	parentGroup.Width:Set(ConfirmationBackground.Width)
	parentGroup.Height:Set(ConfirmationBackground.Height)


	ConfirmationBrackets = Bitmap(parentGroup, '/mods/TargetPriorityChanger/textures/backgroundbrackets.dds')
	ConfirmationBrackets.Depth:Set(function() return parentGroup.Depth() + 20 end)
	LayoutHelpers.AtCenterIn(ConfirmationBrackets, ConfirmationBackground)   
	ConfirmationBrackets.Width:Set(200)
	ConfirmationBrackets.Height:Set(80)
	
	CreatePrioritiesStuff(PrioritiesBackground)
	
	CreateConfirmationButtons(ConfirmationBackground)
	
	EditBackground:DisableHitTest()
	EditBrackets:DisableHitTest()
	PrioritiesBrackets:DisableHitTest()
	PrioritiesBackground:DisableHitTest()
	ConfirmationBrackets:DisableHitTest()
	ConfirmationBackground:DisableHitTest()
	parentGroup:Hide()
end

function HotkeyManager(name)
		UnitsToSetPropFor = table.copy(Selection)
		local set = false
		for k, v in UnitsToSetPropFor do
			for k, wep in v:GetBlueprint().Weapon do
				if wep.TargetPriorities and wep.FireTargetLayerCapsTable[Prefs.GetFromCurrentProfile("saved_prioritiesv1")[name].Type] and string.find(wep.FireTargetLayerCapsTable[Prefs.GetFromCurrentProfile("saved_prioritiesv1")[name].Type],Prefs.GetFromCurrentProfile("saved_prioritiesv1")[name].Type) or name == 'Default' then
					set = true
				end
			end
		end
		if set then
			print('Setting ' .. name .. ' for selected units')
			SimCallback({Func="DataSet",
						 Args={
						 WeaponType = Prefs.GetFromCurrentProfile("saved_prioritiesv1")[name].Type,
						 PriorityList = Prefs.GetFromCurrentProfile("saved_prioritiesv1")[name].List,
						 PriName = name,
						 Default = Prefs.GetFromCurrentProfile("saved_prioritiesv1")[name].Default,
							  }
						},true
					   )
		end

end

function PriorityEditor()
	if parentGroup then
		if not PrioritiesBackground:IsHidden() then
			CloseWindow(PrioritiesBackground, PrioritiesBrackets)
			OpenWindow(EditBackground, EditBrackets)
	 	elseif EditBackground:IsHidden() then 
			OpenWindow(EditBackground, EditBrackets)
			LOG('opening')
		else
			LOG('Closing')
			SaveList:Destroy()
			CloseWindow(EditBackground, EditBrackets)
		end
	else
		CreateMainGroup()
	end

end

function CreateConfirmationButtons(parent)

	DELPText = UIUtil.CreateText(parent, ("Delete priority list?"), 13, UIUtil.titleFont)
	LayoutHelpers.AtCenterIn(DELPText, parent, -15, 0)
	
	OWPText = UIUtil.CreateText(parent, ("Overwrite existing priority?"), 13, UIUtil.titleFont)
	LayoutHelpers.AtCenterIn(OWPText, parent, -15, 0)
	
	YesBtn = UIUtil.CreateButtonStd(parent, "/medium-uef-btn/medium02", "Yes", 15, 2)
	LayoutHelpers.AtLeftTopIn(YesBtn, parent, 35,40)
	YesBtn.Width:Set(60)
	YesBtn.Height:Set(40)
	YesBtn.OnClick = function()
		CloseWindow(ConfirmationBackground, ConfirmationBrackets)
		if OWPText:IsHidden() and PrioritySaveField ~= '' then
			local hotkey = Prefs.GetFromCurrentProfile("saved_prioritiesv1")[PrioritySaveField].Hotkey
			HotkeyTable = {}
			HotkeyTable[hotkey] = {}
			part1 = 'UI_Lua import("/mods/TargetPriorityChanger/hook/lua/ui/game/PriorityList.lua"'
			part2 =  ').HotkeyManager('.. '"' ..PrioritySaveField..'"'..')'
			HotkeyTable[hotkey] = { action = part1..part2, stringkey = 'Priority Hotkey'}
			IN_RemoveKeyMapTable(HotkeyTable)
			local oldprioritylist = Prefs.GetFromCurrentProfile("saved_prioritiesv1")
			local newprioritylist = table.copy(oldprioritylist)
			newprioritylist[PrioritySaveField] = nil
			Prefs.SetToCurrentProfile("saved_prioritiesv1", newprioritylist)
			SaveList.Refresh2()
		else
			CloseWindow(EditBackground, EditBrackets)
			OpenWindow(PrioritiesBackground, PrioritiesBrackets)
		end
	end
	
	NoBtn = UIUtil.CreateButtonStd(parent, "/medium-uef-btn/medium02", "No", 15, 2)
	LayoutHelpers.AtRightTopIn(NoBtn, parent, 35,40)
	NoBtn.Width:Set(60)
	NoBtn.Height:Set(40)
	NoBtn.OnClick = function()
		CloseWindow(ConfirmationBackground, ConfirmationBrackets)
	end
end

function CreateSaveButtons(parent)
	EditBtn = UIUtil.CreateButtonStd(parent, "/medium-uef-btn/medium02", "Edit List", 15, 2)
	LayoutHelpers.AtRightTopIn(EditBtn, parent, 15,133)
	EditBtn.Width:Set(157)
	EditBtn.Height:Set(60)
	EditBtn.OnClick = function()
		PrioritySaveField = saveedit:GetText()
		LOG('Default ; ',SaveList.TableValues[PrioritySaveField].Default)
		if PrioritySaveField ~= '' then
			CloseWindow(EditBackground, EditBrackets)
			OpenWindow(PrioritiesBackground,PrioritiesBrackets)
			hkeyedit:SetText(Prefs.GetFromCurrentProfile("saved_prioritiesv1")[PrioritySaveField].Hotkey)
			typeedit:SetText(Prefs.GetFromCurrentProfile("saved_prioritiesv1")[PrioritySaveField].Type)
			for k, priorities in Prefs.GetFromCurrentProfile("saved_prioritiesv1")[PrioritySaveField].List do
				PriorityFields[k]:SetText(priorities)
			end
		end
	end

	CreateBtn = UIUtil.CreateButtonStd(parent, "/medium-uef-btn/medium02", "Create List", 15, 2)
	LayoutHelpers.AtRightTopIn(CreateBtn, parent,15,23)
	CreateBtn.Width:Set(157)
	CreateBtn.Height:Set(60)
	CreateBtn.OnClick = function()
		PrioritySaveField = saveedit:GetText()
		if PrioritySaveField ~= '' and not SaveList.TableValues[PrioritySaveField].Default then
			if Prefs.GetFromCurrentProfile("saved_prioritiesv1")[PrioritySaveField] then
				OpenWindow(ConfirmationBackground, ConfirmationBrackets)
				DELPText:Hide()
			else
				CloseWindow(EditBackground, EditBrackets)
				OpenWindow(PrioritiesBackground,PrioritiesBrackets)
			end
		end
	end
	
	DeleteBtn = UIUtil.CreateButtonStd(parent, "/medium-uef-btn/medium02", "Delete List", 15, 2)
	LayoutHelpers.AtRightTopIn(DeleteBtn, parent, 15,243)
	DeleteBtn.Width:Set(157)
	DeleteBtn.Height:Set(60)
	DeleteBtn.OnClick = function()
		PrioritySaveField = saveedit:GetText()
		if PrioritySaveField ~= '' and not SaveList.TableValues[PrioritySaveField].Default then
			OpenWindow(ConfirmationBackground,ConfirmationBrackets)
			OWPText:Hide()
		end
	end
	
	CloseBtn = UIUtil.CreateButtonStd(parent, "/medium-uef-btn/medium02", "Close", 15, 2)
	LayoutHelpers.AtRightTopIn(CloseBtn, parent, 45, 315)
	CloseBtn.Width:Set(100)
	CloseBtn.Height:Set(50)
	CloseBtn.OnClick = function()
		PriorityEditor()
	end
end

function CreatePrioritiesStuff(parent)
	CloseBtn = UIUtil.CreateButtonStd(parent, "/medium-uef-btn/medium02", "Close", 15, 2)
	LayoutHelpers.AtRightTopIn(CloseBtn, parent, 17, 300)
	CloseBtn.Width:Set(100)
	CloseBtn.Height:Set(50)
	CloseBtn.OnClick = function()
		PriorityEditor()
	end

	KBtn = UIUtil.CreateButtonStd(parent, "/medium-uef-btn/medium02", "Apply", 15, 2)
	LayoutHelpers.AtRightTopIn(KBtn, parent, 17,260)
	KBtn.Width:Set(100)
	KBtn.Height:Set(50)
	KBtn.OnClick = function()
		if typeedit:GetText() == 'Land' or typeedit:GetText() == 'Air' or typeedit:GetText() == 'Water' or typeedit:GetText() == 'Sub' or PrioritySaveField == 'Default' then
			if PrioritySaveField ~= 'Default' then
				local PriorityListTbl = {}
				for k, field in PriorityFields do
					local priority = field:GetText()
					if priority ~= '' then
						local priority = string.gsub(priority, ' ', '+')
						LOG(priority)
						table.insert(PriorityListTbl, priority)
					end
				end
				local oldprioritylist = Prefs.GetFromCurrentProfile("saved_prioritiesv1")
				local newprioritylist = table.copy(oldprioritylist)
				newprioritylist[PrioritySaveField] = {}
				newprioritylist[PrioritySaveField].List = PriorityListTbl
				newprioritylist[PrioritySaveField].Hotkey = hkeyedit:GetText()
				newprioritylist[PrioritySaveField].Type = typeedit:GetText()
				Prefs.SetToCurrentProfile("saved_prioritiesv1", newprioritylist)
			end
			
			hotkey = hkeyedit:GetText()
			HotkeyTable = {}
			if hotkey ~= '' then
				HotkeyTable[hotkey] = {}
				part1 = 'UI_Lua import("/mods/TargetPriorityChanger/hook/lua/ui/game/PriorityList.lua"'
				part2 =  ').HotkeyManager('.. '"' ..PrioritySaveField..'"'..')'
				HotkeyTable[hotkey] = { action = part1..part2, stringkey = 'Priority Hotkey'}
			end
			IN_AddKeyMapTable(HotkeyTable)
			PriorityEditor()
		end
	end
	
	HKeyText = UIUtil.CreateText(parent, ("Hotkey"), 13, UIUtil.titleFont)
	LayoutHelpers.AtRightTopIn(HKeyText, parent, 40, 50)
	hkeyedit = Edit(HKeyText)
    hkeyedit.Height:Set(20)
    hkeyedit.Width:Set(60)
    UIUtil.SetupEditStd(hkeyedit, UIUtil.fontColor, nil, nil, nil, UIUtil.bodyFont, 13, 40)
    UIUtil.CreateBorder(hkeyedit)
    LayoutHelpers.AtCenterIn(hkeyedit, HKeyText, 40,0)
    
    
	TypeText = UIUtil.CreateText(parent, ("Type"), 13, UIUtil.titleFont)
	LayoutHelpers.AtRightTopIn(TypeText, parent, 49, 135)
	typeedit = Edit(TypeText)
    typeedit.Height:Set(20)
    typeedit.Width:Set(60)
    UIUtil.SetupEditStd(typeedit, UIUtil.fontColor, nil, nil, nil, UIUtil.bodyFont, 13, 40)
    UIUtil.CreateBorder(typeedit)
    LayoutHelpers.AtCenterIn(typeedit, TypeText, 40,0)
    
 	### Priority 1
    text = UIUtil.CreateText(parent, ("1"), 13, UIUtil.titleFont)
    LayoutHelpers.AtLeftTopIn(text, parent, 20, 50)
    priedit1 = Edit(text)
    priedit1.Height:Set(20)
    priedit1.Width:Set(200)
    UIUtil.SetupEditStd(priedit1, UIUtil.fontColor, nil, nil, nil, UIUtil.bodyFont, 13, 40)
    UIUtil.CreateBorder(priedit1)
    LayoutHelpers.AtCenterIn(priedit1, text, 0,150)
    
  	### Priority 2
    text2 = UIUtil.CreateText(parent, ("2"), 13, UIUtil.titleFont)
    LayoutHelpers.AtCenterIn(text2, text, 45, 0)
    priedit2 = Edit(text2)
    priedit2.Height:Set(20)
    priedit2.Width:Set(200)
    UIUtil.SetupEditStd(priedit2, UIUtil.fontColor, nil, nil, nil, UIUtil.bodyFont, 13, 40)
    UIUtil.CreateBorder(priedit2)
    LayoutHelpers.AtCenterIn(priedit2, text2, 0,150)
    
  	### Priority 3
    text3 = UIUtil.CreateText(parent, ("3"), 13, UIUtil.titleFont)
    LayoutHelpers.AtCenterIn(text3, text2, 45, 0)
    priedit3 = Edit(text3)
    priedit3.Height:Set(20)
    priedit3.Width:Set(200)
    UIUtil.SetupEditStd(priedit3, UIUtil.fontColor, nil, nil, nil, UIUtil.bodyFont, 13, 40)
    UIUtil.CreateBorder(priedit3)
    LayoutHelpers.AtCenterIn(priedit3, text3, 0,150)
    
  	### Priority 4
    text4 = UIUtil.CreateText(parent, ("4"), 13, UIUtil.titleFont)
    LayoutHelpers.AtCenterIn(text4, text3, 45, 0)
    priedit4 = Edit(text)
    priedit4.Height:Set(20)
    priedit4.Width:Set(200)
    UIUtil.SetupEditStd(priedit4, UIUtil.fontColor, nil, nil, nil, UIUtil.bodyFont, 13, 40)
    UIUtil.CreateBorder(priedit4)
    LayoutHelpers.AtCenterIn(priedit4, text4, 0,150)
    
  	### Priority 5
    text5 = UIUtil.CreateText(parent, ("5"), 13, UIUtil.titleFont)
    LayoutHelpers.AtCenterIn(text5, text4, 45,0)
    priedit5 = Edit(text)
    priedit5.Height:Set(20)
    priedit5.Width:Set(200)
    UIUtil.SetupEditStd(priedit5, UIUtil.fontColor, nil, nil, nil, UIUtil.bodyFont, 13, 40)
    UIUtil.CreateBorder(priedit5)
    LayoutHelpers.AtCenterIn(priedit5, text5, 0,150)
    
  	### Priority 6
    text6 = UIUtil.CreateText(parent, ("6"), 13, UIUtil.titleFont)
    LayoutHelpers.AtCenterIn(text6, text5, 45, 0)
    priedit6 = Edit(text6)
    priedit6.Height:Set(20)
    priedit6.Width:Set(200)
    UIUtil.SetupEditStd(priedit6, UIUtil.fontColor, nil, nil, nil, UIUtil.bodyFont, 13, 40)
    UIUtil.CreateBorder(priedit6)
    LayoutHelpers.AtCenterIn(priedit6, text6, 0,150)
    
  	### Priority 7
    text7 = UIUtil.CreateText(parent, ("7"), 13, UIUtil.titleFont)
    LayoutHelpers.AtCenterIn(text7, text6, 45, 0)
    priedit7 = Edit(text7)
    priedit7.Height:Set(20)
    priedit7.Width:Set(200)
    UIUtil.SetupEditStd(priedit7, UIUtil.fontColor, nil, nil, nil, UIUtil.bodyFont, 13, 40)
    UIUtil.CreateBorder(priedit7)
    LayoutHelpers.AtCenterIn(priedit7, text7, 0,150)
    
  	### Priority 8
    text8 = UIUtil.CreateText(parent, ("8"), 13, UIUtil.titleFont)
    LayoutHelpers.AtCenterIn(text8, text7, 45, 0)
    priedit8 = Edit(text8)
    priedit8.Height:Set(20)
    priedit8.Width:Set(200)
    UIUtil.SetupEditStd(priedit8, UIUtil.fontColor, nil, nil, nil, UIUtil.bodyFont, 13, 40)
    UIUtil.CreateBorder(priedit8)
    LayoutHelpers.AtCenterIn(priedit8, text8, 0,150)
    PriorityFields = {priedit1,priedit2,priedit3,priedit4,priedit5,priedit6,priedit7,priedit8}
    
	######################################
	# ListBox functions
	######################################
	
    local priFieldList = false
    local raisePriFieldList = true
    priedit1.OnTextChanged = function(self, newText, oldText)
        if raisePriFieldList then
            if priFieldList then
                priFieldList:Destroy()
                priFieldList = false
            end
            local matches = UnitPriFunc(newText)
            local numMatches = table.getn(matches)
            if (numMatches > 0) then
                priFieldList = ItemList(self)
                priFieldList:SetFont(UIUtil.bodyFont, 13)
                LayoutHelpers.Below(priFieldList, self,13)
                LayoutHelpers.DepthOverParent(priFieldList, self,2)
                priFieldList.Right:Set(function() return self.Right() end)
                priFieldList.Height:Set(function()
                    return (priFieldList:GetRowHeight() * numMatches)
                end)
                for i,v in matches do
                    priFieldList:AddItem(v)
                end
				UIUtil.CreateBorder(priFieldList)
                priFieldList:SetSelection(priFieldList:GetItemCount() - 1)
                priedit = self
                priFieldList.OnDoubleClick = function(self, row)
                    priedit:SetText(priFieldList:GetItem(row))
                    priedit:AcquireFocus()
                end
            end
         end
    end
    priedit2.OnTextChanged = function(self, newText, oldText)
    	priedit1.OnTextChanged(self, newText, oldText)
    end
    priedit3.OnTextChanged = function(self, newText, oldText)
    	priedit1.OnTextChanged(self, newText, oldText)
    end
    priedit4.OnTextChanged = function(self, newText, oldText)
    	priedit1.OnTextChanged(self, newText, oldText)
    end
    priedit5.OnTextChanged = function(self, newText, oldText)
    	priedit1.OnTextChanged(self, newText, oldText)
    end
    priedit6.OnTextChanged = function(self, newText, oldText)
    	priedit1.OnTextChanged(self, newText, oldText)
    end
	priedit7.OnTextChanged = function(self, newText, oldText)
    	priedit1.OnTextChanged(self, newText, oldText)
    end
	priedit8.OnTextChanged = function(self, newText, oldText)
    	priedit1.OnTextChanged(self, newText, oldText)
    end
    
    function UnitPriFunc(newText)
	    while true do
	    	local UnitTable = {
								'SELECTABLE',
								'BUILTBYTIER3FACTORY',
								'AEON',
								'MOBILE',
								'AIR',
								'HIGHALTAIR',
								'TECH3',
								'INTELLIGENCE',
								'RADAR',
								'VISIBLETORECON',
								'RECLAIMABLE',
								'UEF',
								'LAND',
								'DIRECTFIRE',
								'SHIELD',
								'STRUCTURE',
								'TECH1',
								'BUILTBYTIER2ENGINEER',
								'BUILTBYTIER3ENGINEER',
								'BUILTBYTIER2COMMANDER',
								'DEFENSE',
								'TECH2',
								'ANTIAIR',
								'DRAGBUILD',
								'SIZE4',
								'SONAR',
								'BUILTBYTIER3COMMANDER',
								'ANTIMISSILE',
								'SILO',
								'SIZE8',
								'BUILTBYTIER1ENGINEER',
								'BUILTBYCOMMANDER',
								'COUNTERINTELLIGENCE',
								'SIZE9',
								'NEEDMOBILEBUILD',
								'TRANSPORTATION',
								'TRANSPORTFOCUS',
								'CYBRAN',
								'ENGINEER',
								'CONSTRUCTION',
								'REPAIR',
								'RECLAIM',
								'REBUILDER',
								'BUILTBYQUANTUMGATE',
								'CAPTURE',
								'SUBCOMMANDER',
								'PATROLHELPER',
								'BUILTBYTIER1FACTORY',
								'BUILTBYTIER2FACTORY',
								'INDIRECTFIRE',
								'ARTILLERY',
								'STRATEGIC',
								'NUKE',
								'ECONOMIC',
								'MASSPRODUCTION',
								'MASSFABRICATION',
								'SIZE12',
								'NAVAL',
								'FACTORY',
								'RALLYPOINT',
								'CONSTRUCTIONSORTDOWN',
								'SIZE16',
								'UNTARGETABLE',
								'FERRYBEACON',
								'TELEPORTBEACON',
								'CIVILIAN',
								'SCOUT',
								'ENERGYPRODUCTION',
								'EXPERIMENTAL',
								'ANTINAVY',
								'COMMAND',
								'MASSEXTRACTION',
								'OMNI',
								'TACTICALMISSILEPLATFORM',
								'GROUNDATTACK',
								'WALL',
								'BENIGN',
								'BOMBER',
								'CANTRANSPORTCOMMANDER',
								'HOVER',
								'AIRSTAGINGPLATFORM',
								'ANTISUB',
								'GATE',
								'SIZE20',
								'OPERATION',
								'SPECIALLOWPRI',
								'BUILTBYEXPERIMENTALSUB',
								'MASSSTORAGE',
								'SPECIALHIGHPRI',
								'ENERGYSTORAGE',
								'SUBMERSIBLE',
								'CARRIER',
								'HYDROCARBON',
								'PODSTAGINGPLATFORM',
								'POD',
								'RECLAIMFRIENDLY',
								'NOFORMATION',
								'INSIGNIFICANTUNIT',
								}
	    	local Names = {}
		    for k, name in UnitTable do
		    	local vname = string.lower(name)
		    	local vnewText = string.lower(newText)
				local textlenght = string.len(vnewText)
				local matchtext = string.sub(vname,0, textlenght)
				if vnewText == matchtext and textlenght ~= string.len(name)  then
					if vnewText ~= '' then
-- 						LOG('Adding : ',name)
						table.insert(Names,name)
					end
				else
					if table.find(Names, name) then
						table.remove(Names, k)
					end
			    end
		    end
	        return Names
	    end
    end
    
    
end

function OpenWindow(bg,brackets)
	bg:Show()
	brackets:Show()
	if not SaveList and bg == EditBackground then
		SaveList = PriorityList(EditBackground,30,30,172,25,{},11,true)
		saveedit = Edit(SaveList)
		saveedit.Height:Set(20)
		saveedit.Width:Set(161)
		saveedit:ShowBackground(true)
		UIUtil.SetupEditStd(saveedit, UIUtil.fontColor, nil, nil, nil, UIUtil.bodyFont, 13, 40)
		UIUtil.CreateBorder(saveedit)
		LayoutHelpers.AtCenterIn(saveedit, SaveList,110,-104)
		SaveList:Show()
	end
	if bg == EditBackground then
		SaveList.AddFields(Prefs.GetFromCurrentProfile("saved_prioritiesv1"))
	end
	local sound = Sound({Cue = "UI_Main_Window_Open", Bank = "Interface",})
	PlaySound(sound)
 	bg:SetNeedsFrameUpdate(true)
    bg:SetAlpha(0, true)
    local totalTime = 0
	local braceGoal = bg.Height()
	local braceGoal2 = bg.Width()

    brackets:SetAlpha(1)
    brackets.Width:Set(1)
    brackets.Height:Set(1)
    local AnimationCues = {
        stage1 = {
            started = true,
            running = true,
        },
        stage2 = {
            started = false,
            running = false,
        },
        stage3 = {
            started = false,
            running = false,
        },
        stage4 = {
            started = false,
            running = false,
        },
        stage5 = {
            started = false,
            running = false,
        },
        stage6 = {
            started = false,
            running = false,
        },
        stage7 = {
            started = false,
            running = false,
        },
        stage8 = {
            started = false,
            running = false,
        },
        stage9 = {
            started = false,
            running = false,
        },
        stage10 = {
            started = false,
            running = false,
        },
    }
    local function FadeIn(control, elapsedTime, speed, cue)
        if control:GetAlpha() < 1 then
            local curAlpha = math.min(control:GetAlpha() + (elapsedTime * speed), 1)
            control:SetAlpha(curAlpha, true)
        else
            cue = false
        end
    end
            
    bg.OnFrame = function(self, elapsedTime)
        totalTime = totalTime + elapsedTime
        if totalTime > .2 and not AnimationCues.stage2.started then
            AnimationCues.stage2.started = true
            AnimationCues.stage2.running = true
        end
        if totalTime > .5 and not AnimationCues.stage3.started then
            AnimationCues.stage3.started = true
            AnimationCues.stage3.running = true
        end
        if totalTime > .8 and not AnimationCues.stage4.started and not AnimationCues.stage3.running then
            AnimationCues.stage4.started = true
            AnimationCues.stage4.running = true
        end
        if totalTime > 0.85 and not AnimationCues.stage5.started and not AnimationCues.stage4.running then
            AnimationCues.stage5.started = true
            AnimationCues.stage5.running = true
        end
        if totalTime > 0.9 and not AnimationCues.stage6.started then
            AnimationCues.stage6.started = true
            AnimationCues.stage6.running = true
        end
        if totalTime > 0.95 and not AnimationCues.stage7.started then
            AnimationCues.stage7.started = true
            AnimationCues.stage7.running = true
        end
        if totalTime > 1 and not AnimationCues.stage8.started then
            AnimationCues.stage8.started = true
            AnimationCues.stage8.running = true
        end
        if totalTime > 1.05 and not AnimationCues.stage9.started then
            AnimationCues.stage9.started = true
            AnimationCues.stage9.running = true
        end
        if totalTime > 1.2 and not AnimationCues.stage10.started then
            AnimationCues.stage10.started = true
            AnimationCues.stage10.running = true
            bg:SetNeedsFrameUpdate(false)
        end
        if AnimationCues.stage6.running then
		end
        if AnimationCues.stage4.running then
			FadeIn(bg, elapsedTime, 4, AnimationCues.stage4.running)
        end
		if AnimationCues.stage2.running then
            if  brackets.Width() > braceGoal2 then
                 brackets.Width:Set(braceGoal2)
                 AnimationCues.stage2.running = false
            else
                local curWidth = brackets.Width()
                if curWidth + (elapsedTime * 2000) > braceGoal2 + 50 then
                    brackets.Width:Set(braceGoal2)
                    AnimationCues.stage2.running = false
                else
                    brackets.Width:Set(function() return curWidth + (elapsedTime * 2000) end)
                end
            end
		end
        if AnimationCues.stage3.running then
            if  brackets.Height() > braceGoal then
                 brackets.Height:Set(braceGoal)
                 AnimationCues.stage3.running = false
            else
                local curHeight = brackets.Height()
                if curHeight + (elapsedTime * 2000) > braceGoal + 50 then
                    brackets.Height:Set(braceGoal)
                    AnimationCues.stage3.running = false
                else
                    brackets.Height:Set(function() return curHeight + (elapsedTime * 2000) end)
                end
            end
        end
	end
end

#################################
##	##	##	##	##	##	##	##	#
# Main window close animation
##	##	##	##	##	##	##	##	#
#################################

function CloseWindow(bg,brackets)
	if SaveList and bg == EditBackground then
		SaveList:Destroy()
		SaveList = false
	end
	local sound = Sound({Cue = "UI_Main_Window_Close", Bank = "Interface",})
    bg:SetNeedsFrameUpdate(true)
    local braceGoal = 1
    local braceGoal2 = 1
    local totalTime = 0
    local AnimationCues = {
        stage1 = {
        	FadeOut = false,
            started = true,
            running = true,
        },
        stage2 = {
            started = false,
            running = false,
        },
        stage3 = {
            started = false,
            running = false,
        },
    }
    local function FadeOut(control, elapsedTime, speed, cue)
        if control:GetAlpha() > 0 then
            local curAlpha = math.max(control:GetAlpha() - (elapsedTime * speed), 0)
            control:SetAlpha(curAlpha, true)
        else
        	if cue then
				cue = false
			end
        end
    end
    bg.OnFrame = function(self, elapsedTime)
        totalTime = totalTime + elapsedTime
        if totalTime > .2 and not AnimationCues.stage2.started then
            AnimationCues.stage2.started = true
            AnimationCues.stage2.running = true
        end
        if totalTime > .4 and not AnimationCues.stage3.started then
            AnimationCues.stage3.started = true
            AnimationCues.stage3.running = true
        end
        if totalTime > .9 then
            bg:SetNeedsFrameUpdate(false)
	        bg:Hide()
	        brackets:Hide()
        end
        if AnimationCues.stage1.running then
			FadeOut(bg, elapsedTime, 4, AnimationCues.stage1.running)
        end
        if AnimationCues.stage2.running then
            if  brackets.Height() <= braceGoal then
                 brackets.Height:Set(braceGoal)
                 AnimationCues.stage2.running = false
            else
                local curHeight = brackets.Height()
                if curHeight - (elapsedTime * 1500) < 0 then
                    brackets.Height:Set(braceGoal)
                    AnimationCues.stage2.running = false
                else
                    brackets.Height:Set(function() return curHeight - (elapsedTime * 1500) end)
                end
            end
        end
        if AnimationCues.stage3.running then
            if  brackets.Width() <= braceGoal then
                 brackets.Width:Set(braceGoal)
                 AnimationCues.stage3.running = false
            else
                local curWidth = brackets.Width()
                if curWidth - (elapsedTime * 1500) < 0 then
                    brackets.Width:Set(braceGoal)
                    AnimationCues.stage3.running = false
                else
                    brackets.Width:Set(function() return curWidth - (elapsedTime * 1500) end)
                end
            end
        end
    end
end

#################################
##	##	##	##	##	##	##	##	#
# Base Function by Saya, Cleopatre, Goom
##	##	##	##	##	##	##	##	#
#################################

function PriorityList(parent,left,top,width,nbr_car,itemTab,length,savelist)

    local top_reel=function() return parent.Top() + top end 
    local left_reel=function() return parent.Left() + left end
	local lineheight = 26
	local bgcolour = "Black"
	local textcolour = "FFbadbdb"
	local bgovercolour = "Black"
	local txtovercolour = "White"
	local txtselectedcolour = "Black"
	local bgselectedcolour = "Gray"
	local txtselectedovercolour = "White"
	local bgselectedovercolour = "Gray"
	local categorycolour = "34463C"
	local ListBox = Group(parent)
	ListBox.Depth:Set(function() return parent.Depth()+1 end)
    LayoutHelpers.AtCenterIn(ListBox, parent, left, top)
	ListBox.Width:Set(50)
	ListBox.Height:Set(50)
	ListBox.Depth:Set(parent.Depth()+5)
	ListBox:DisableHitTest()

	--background table
	local bg = {}
	--text table
	local txt = {}
	
	ListBox.Values = {}
	ListBox.SelectedValues = {}
	
	--p is the current position in the ListBox
	ListBox.p = 1
	--i is the current index in the ListBox
	ListBox.i = 1
	--r is the real index in the ListBox
	ListBox.r = 1
	
	ListBox.endIndex = 0	

	ListBox.OnSelect = function()
		if savelist then
			saveedit:SetText(ListBox.Values[ListBox.p + ListBox.i - 1])
		else
-- 			local valuetable = table.copy(ListBox.TableValues[ListBox.Values[ListBox.p + ListBox.i - 1]].List)
-- 			local convertednames = ConvertNameToId(valuetable)
-- 			LOG(repr(convertednames))
			local set = false
			local name = ListBox.Values[ListBox.p + ListBox.i - 1]
			for k, v in Selection do
				for k, wep in v:GetBlueprint().Weapon do
					if wep.TargetPriorities and wep.FireTargetLayerCapsTable[Prefs.GetFromCurrentProfile("saved_prioritiesv1")[name].Type] and string.find(wep.FireTargetLayerCapsTable[Prefs.GetFromCurrentProfile("saved_prioritiesv1")[name].Type],Prefs.GetFromCurrentProfile("saved_prioritiesv1")[name].Type) or name == 'Default' then
						set = true
					end
				end
			end
			if set then
			print('Setting ' .. name .. ' for selected units')
				SimCallback({Func="DataSet",
							 Args={
							 WeaponType = ListBox.TableValues[ListBox.Values[ListBox.p + ListBox.i - 1]].Type,
							 PriorityList = ListBox.TableValues[ListBox.Values[ListBox.p + ListBox.i - 1]].List,
							 Default = ListBox.TableValues[ListBox.Values[ListBox.p + ListBox.i - 1]].Default,
							 PriName = ListBox.Values[ListBox.p + ListBox.i - 1],
								  }
							},true
					       )
			end
		end      
	end
	
	local createBgTable = function()
		local bordertl = Bitmap(ListBox)
		bordertl:SetTexture(UIUtil.SkinnableFile('/game/generic_brd/generic_brd_ul.dds'))
		bordertl.Top:Set(top_reel)
		bordertl.Left:Set(left_reel)
		local bordertr = Bitmap(ListBox)
		bordertr:SetTexture(UIUtil.SkinnableFile('/game/generic_brd/generic_brd_ur.dds'))
		bordertr.Top:Set(top_reel)
		bordertr.Right:Set(left_reel() + width)
		local bordertop = Bitmap(ListBox)
		bordertop:SetTexture(UIUtil.SkinnableFile('/game/generic_brd/generic_brd_horz_um.dds'))
		bordertop.Top:Set(top_reel)
		bordertop.Left:Set(bordertl.Right)
		bordertop.Right:Set(bordertr.Left)
		local borderbottom = Bitmap(ListBox)
		borderbottom:SetTexture(UIUtil.SkinnableFile('/game/generic_brd/generic_brd_horz_lm.dds'))
		borderbottom.Top:Set(top_reel() + bordertop.Height() + length*lineheight - 3)
		borderbottom.Left:Set(bordertl.Right)
		borderbottom.Right:Set(bordertr.Left)
		local borderbl = Bitmap(ListBox)
		borderbl:SetTexture(UIUtil.SkinnableFile('/game/generic_brd/generic_brd_ll.dds'))
		borderbl.Top:Set(borderbottom.Top)
		borderbl.Left:Set(left_reel)
		local borderbr = Bitmap(ListBox)
		borderbr:SetTexture(UIUtil.SkinnableFile('/game/generic_brd/generic_brd_lr.dds'))
		borderbr.Top:Set(borderbottom.Top)
		borderbr.Right:Set(left_reel() + width)
		local borderleft = Bitmap(ListBox)
		borderleft:SetTexture(UIUtil.SkinnableFile('/game/generic_brd/generic_brd_vert_l.dds'))
		borderleft.Top:Set(bordertl.Bottom)
		borderleft.Left:Set(left_reel)
		borderleft.Bottom:Set(borderbl.Top)
		local borderright = Bitmap(ListBox)
		borderright:SetTexture(UIUtil.SkinnableFile('/game/generic_brd/generic_brd_vert_r.dds'))
		borderright.Top:Set(bordertl.Bottom)
		borderright.Right:Set(left_reel() + width)
		borderright.Bottom:Set(borderbl.Top)
		
		local k = 1
		while k <= length do
			local index = k 

			bg[k] = Bitmap(ListBox)	
			if k == 1 then
				bg[k].Top:Set(bordertop.Bottom() - 2)
			else
				bg[k].Top:Set(bg[k-1].Bottom)
			end
			bg[k].Height:Set(lineheight)
			bg[k].Left:Set(borderleft.Right() - 1)
			bg[k].Width:Set(borderright.Left() - borderleft.Right() + 3)
			bg[k].Depth:Set(ListBox.Depth()) 		

			txt[k] = UIUtil.CreateText(bg[k], "" , 13, UIUtil.fixedFont)
			txt[k]:SetColor(textcolour)
			LayoutHelpers.AtLeftTopIn(txt[k], bg[k], 13, 4)
			txt[k].Depth:Set(bg[k].Depth()+20)			
			local text = txt[index]:GetText()
			txt[k].bmp = Bitmap(ListBox)
			txt[k].bmp.Top:Set(txt[k].Top())
			txt[k].bmp.Left:Set(txt[k].Left()+10)


			bg[k].HandleEvent = function(self, event)
				if ListBox.Values[ListBox.p + index - 1] then
					if (event.Type == 'ButtonPress') then
						if ListBox.Values[ListBox.p + ListBox.i - 1] and table.find(ListBox.SelectedValues, ListBox.Values[ListBox.p + index - 1]) then
						txt[index]:SetColor(textcolour)
							bg[index]:SetSolidColor(bgcolour)
							for k, value in ListBox.SelectedValues do
								if value == ListBox.Values[ListBox.p + index - 1] then
									table.remove(ListBox.SelectedValues, k)
								end
							end
							#LOG(repr(ListBox.Values))
							ListBox.i = index
							ListBox.r = ListBox.p + ListBox.i - 1
	 					else
	 												ListBox.i = index
							ListBox.r = ListBox.p + ListBox.i - 1
	 						txt[index]:SetColor(textcolour)
	 					end
	 						
		 				ListBox.OnSelect()
		 					
		 			elseif (event.Type == 'MouseEnter') then
		 				if  not table.find(ListBox.SelectedValues, ListBox.Values[ListBox.p + index - 1]) then
		 					bg[index]:SetSolidColor(bgovercolour)
		 					txt[index]:SetColor(txtovercolour)
							priList = ItemList(ListBox)
							priList:SetFont(UIUtil.bodyFont, 13)
							str_max_len = false
							for k, text in ListBox.TableValues[ListBox.Values[index]].List do
								str_len = string.len(text)
								if not str_max_len then
									str_max_len = 0
								end
								if str_len > str_max_len then
									str_max_len = str_len
								end
							end
							if str_max_len < 19 then
								priList.Right:Set(left_reel() + width -3)
							else
								priList.Right:Set(left_reel() + width -3 + str_max_len *1.75)
							end
							if savelist then
								priList.Bottom:Set(function() return ListBox.Top() - 180 end)
								--priList.Right:Set(left_reel() + width *2 -22)
							else
							--	priList.Right:Set(left_reel() + width *2)
								priList.Bottom:Set(function() return top - 4 end)
							end
							priList.Left:Set(left_reel() + 6)
							LayoutHelpers.DepthOverParent(priList, ListBox,1)
							priList.Height:Set(function()
								return (priList:GetRowHeight() * table.getn(ListBox.TableValues[ListBox.Values[index]].List))
							end)
							for k, priority in ListBox.TableValues[ListBox.Values[index]].List do
								priList:AddItem(k .. ' ' .. priority)
							end
							UIUtil.CreateBorder(priList)
	 					elseif table.find(ListBox.SelectedValues, ListBox.Values[ListBox.p + index - 1]) then
	 						bg[index]:SetSolidColor(bgselectedovercolour)
		 					txt[index]:SetColor(txtselectedovercolour)
		 				end
		 			elseif (event.Type == 'MouseExit') then	
		 				if not table.find(ListBox.SelectedValues, ListBox.Values[ListBox.p + index - 1]) then
		 					txt[index]:SetColor(textcolour)
		 					bg[index]:SetSolidColor(bgcolour)
							if priList then
	 							priList:Destroy()
		 						priList = false
		 					end
		 				elseif table.find(ListBox.SelectedValues, ListBox.Values[ListBox.p + index - 1]) then
		 					txt[index]:SetColor(txtselectedcolour)
		 					bg[index]:SetSolidColor(bgselectedcolour)
		 				end
		 			end
				end
			end	
		k = k + 1 
		end
	end

	ListBox.Refresh2 = function()
		ListBox.Clear()
		ListBox.AddFields(Prefs.GetFromCurrentProfile("saved_prioritiesv1"))
	end
	
	ListBox.HandleEvent = function(self, event)    
		if event.Type=="WheelRotation" then 
			if event.WheelRotation <= 0 then 
				if ListBox.p < ListBox.endIndex - length + 1 then 
					local newPosition = ListBox.p + 1 
					ListBox.SetPosition(newPosition)
					ListBox.Refresh()
				end 
			else 
				if ListBox.p > 1 then 
					local newPosition = ListBox.p - 1 
					ListBox.SetPosition(newPosition)
					ListBox.Refresh()
				end 
			end 
		end 
	end

	
	ListBox.Refresh = function()
		for k,v in bg do
			if bg[k] ~= nil then
				if ListBox.endIndex <= length then
					ListBox.p = 1
				end				
				local showpos = ListBox.p+(k-1)
				--LOG(repr(ListBox.Values))
				bg[k]:SetSolidColor(bgcolour)
				if ListBox.Values != nil and txt[k] != nil  then
					if not table.find(ListBox.SelectedValues,txt[k]:GetText()) then
						txt[k]:SetColor(textcolour)
						#LOG(txt[k]:GetText(), ' found at', k)
					else
						#LOG('selected ',txt[k]:GetText(), ' found at', k)
						txt[k]:SetColor(txtselectedcolour)
						bg[k]:SetSolidColor(bgselectedcolour)
					end
					if ListBox.Values[showpos] != nil then
						#LOG(ListBox.Values[showpos], ' ', k)
						local text = string.gsub( ListBox.Values[showpos], "^<(.*)>(.*)$", "%2" )	
						txt[k]:SetText(string.sub(text,0,nbr_car))
						txt[k].Left:Set(function() return left_reel() + 13 end)
					else
						#LOG('empty at ; ', k)
						txt[k]:SetText("")
						txt[k].bmp:SetTexture(pathuiimg..'/empty_sca.dds')
						txt[k].Left:Set(function() return left_reel() + 13 end)
					end
				end
			end		
		end
	end




	
	createBgTable()
	
	#################################
	##	##	##	##	##	##	##	##	#
	# Misc. Functions
	##	##	##	##	##	##	##	##	#
	#################################

	
	ListBox.IsValueSelected = function(v)
		if table.find(ListBox.SelectedValues, v) then
			return true
		else
			return false
		end
	end
	
	
	ListBox.IsSelected = function()
		if table.getn(ListBox.SelectedValues) > 0 then
			return true
		else
			return false
		end
	end
	
	ListBox.Clear = function()
		ListBox.Values = {}
		--p is the current position in the ListBox
		ListBox.p = 1
		--i is the current index in the ListBox
		ListBox.i = 1
		--r is the real index in the ListBox
		ListBox.r = 1
	    ListBox.endIndex = 0
	    ListBox.SelectedValues = {}
		ListBox.SetPosition(1)
	end
	
	
	ListBox.LookFor = function(e, faction)
		local result = false
		if table.find(ListBox.Values[faction], e) then
			result = true
		else
			result = false
		end
		return result
	end

   
	ListBox.GetSelectedValues = function()
		return ListBox.SelectedValues
	end
	
	
	ListBox.SetPosition = function(position)
		ListBox.p = position
		ListBox.Refresh()
	end
	

	ListBox.GetIndex = function()
		local listIndex = ListBox.p+ListBox.i-1
		return listIndex
	end
	
	
	ListBox.LookFor2 = function(e)
		local result = ListBox.p
		if table.getn(ListBox.Values) ~= nil then
			for i,v in ListBox.Values do
				if v == e then
					 result = i
				end
			end
		end
		return result
	end
	

	ListBox.GetValues = function()
		return ListBox.Values
	end
	
	#################################
	##	##	##	##	##	##	##	##	#
	# Add/Remove Functions
	##	##	##	##	##	##	##	##	#
	#################################
	
	ListBox.AddToSelectedValues = function(v, unit)
		if unit then
			if not ListBox.SelectedValues[unit] then
				ListBox.SelectedValues[unit] = {}
			end
			table.insert(ListBox.SelectedValues[unit],v)
		end
		table.insert(ListBox.SelectedValues, v)
	end
	
	ListBox.AddElement = function(v,n, unit)
		if not n then
			n = table.getn(ListBox.Values)
		end
		if unit then
			if not ListBox.Values[unit] then
				ListBox.Values[unit] = {}
			end
			table.insert(ListBox.Values[unit],v)
		else
			table.insert(ListBox.Values,n,v)
		end
		ListBox.endIndex = ListBox.endIndex + 1
		ListBox.Refresh()
	end
	
	ListBox.RemoveElement = function(k)
		for i, value in ListBox.Values do
			if value == k then
				table.remove(ListBox.Values,i)
				#LOG(value, '  ', i)
			end
		end
		for l, v in ListBox.SelectedValues do
			if v == k then
				table.remove(ListBox.SelectedValues, l)
			end
		end
		ListBox.endIndex = ListBox.endIndex - 1	 
		ListBox.Refresh()
	end

	
	ListBox.AddFields = function(ptable)
		ListBox.Clear()
		ListBox.TableValues = ptable
		for k, v in ptable do
				table.insert(ListBox.Values,k)
				ListBox.endIndex = ListBox.endIndex + 1
		end
		ListBox.Refresh()
	end  
      
	--function to select an item in the ListBox
	--index is the index of the item in the list
	--if exe is true the OnSelect() function of the list will be called
	--if boolean is true the list will be shown/Refreshed else it will not change its ishidden state
	ListBox.Select = function(index,exe,boolean)
		local showList = true
		if boolean != nil then
			showList = boolean
		end
		
		local run = true
		if exe != nil then
			run = exe
		end
		ListBox.r = index
		ListBox.i = 1
			
		if showList == true then
		ListBox.SetPosition(ListBox.r-3)
		end

		if run == true then
			OnSelect()
		end
	end
	
	--init
	ListBox.i = 1
	ListBox.Select(1,false) 
	
	return ListBox
end

function ConvertNameToId(nametable)
	UnitNameTable = {
			MASSEXTRACTOR={"UAB1103","UAB1202","UAB1302","UEB1103","UEB1202","UEB1302","URB1103","URB1202","URB1302"},
			
			WALL={"URB5101","UAB5101","UEB5101"},
			
			T1ENERGYSTORAGE={"UEB1105","URB1105","UAB1105"},
			T1MASSSTORAGE={"UEB1106","URB1106","UAB1106"},
			
			T2AIRSTAGING={"URB5202","UAB5202","UEB5202"},
			
			TML={"UEB2108","UAB2108","URB2108"},
			TMD={"UEB4201","UAB4201","URB4201"},
			
			
			T1PD={"UEB2101","UAB2101","URB2101"},
			T2PD={"URB2301","UAB2301","UEB2301"},
			
			T1STATICAA={"UEB2104","UAB2104","URB2104"},
			T2STATICAA={"UEB2204","UAB2204","URB2204"},
			T3STATICAA={"UEB2304","URB2304","UAB2304"},
			
			T2TL={"URB2205","UAB2205","UEB2205"},
			T1TL={"UEB2109","URB2109","UAB2109"},
			
			T1SONAR={"URB3102","UEB3102","UAB3102"},
			T2SONAR={"URB3202","UEB3202","UAB3202"},
			T3SONAR={"UES0305","URS0305","UAS0305"},
			
			SHIELDGENERATOR={"URB4202","URB4207","URB4206","URB4205","URB4204","UEB4202","UAB4202","UEB4301","UAB4301"},
			
			
			T1MASSFAB={"UAB1104","URB1104","UEB1104"},
			T3MASSFAB={"UEB1303","URB1303","UAB1303"},
			
			QUANTUMGATE={"UAB0304","UEB0304","URB0304"},
			
			T2AIRFACTORY={"UAB0202","UEB0202","URB0202"},
			T2NAVALFACTORY={"URB0203","UEB0203","UAB0203"},
			T2LANDFACTORY={"UAB0201","URB0201","UEB0201"},
			
			T3AIRFACTORY={"UEB0302","URB0302","UAB0302"},
			T3LANDFACTORY={"UAB0301","URB0301","UEB0301"},
			T3NAVALFACTORY={"UAB0303","UEB0303","URB0303"},
			
			T1RADAR={"URB3101","UAB3101","UEB3101"},
			T2RADAR={"URB3201","UEB3201UAB3201"},
			T3RADAR={"URB3104","UAB3104","UEB3104"},
			
			
			NUKE={"UAB2305","URB2305","UEB2305"},
			SMD={"URB4302","UEB4302","UAB4302"},
			
			T2STATICARTY={"URB2303","UEB2303","UAB2303"},
			T3STATICARTY={"URB2302","UEB2302","UAB2302"},
			
			T1PGEN={"UEB1101","URB1101","UAB1101"},
			HYDROCARBON={"UEB1102","UAB1102","URB1102"},
			T2PG={"UEB1201","URB1201UAB1201"},
			T3PG={"UEB1301","URB1301","UAB1301"},
			
			SFG={"UEB4203","URB4203"},
			
			
			
			ACU={"UEL0001","UAL0001","URL0001"},
			
			SUB={"URS0203","UAS0203","UES0203"},
			ATTACKBOAT={"UAS0102"},
			FRIGATE={"UAS0103","UES0103","URS0103"},
			DESTROYER={"UAS0201","URS0201","UES0201"},
			CRUISER={"UES0202","UAS0202","URS0202"},
			T3STRATEGICSUB={"UES0304","URS0304","UAS0304"},
			CARRIER={"URS0303","UAS0303"},
			BATTLESHIP={"URS0302","UAS0302","UES0302"},
			
			T1TRANSPORT={"UAA0107","UEA0107","URA0107"},
			T2TRANSPORT={"UAA0104","UEA0104","URA0104"},
			
			T1ENGINEER={"UAL0105","URL0105UEL0105"},
			T2ENGINEER={"UAL0208","URL0208","UEL0208"},
			T3ENGINEER={"UAL0309","UEL0309","URL0309"},
			
			T1MOBILEAA={"UEL0104","URL0104","UAL0104"},
			T2MOBILEAA={"UAL0205","URL0205","UEL0205"},
			
			T1MOBILEARTY={"UAL0103","UEL0103","URL0103"},
			MML={"UAL0111","UEL0111","URL0111"},
			T3MOBILEARTY={"UEL0304","UAL0304","URL0304"},
			
			LAB={"UAL0106","URL0106","UEL0106"},
			LANDSCOUT={"URL0101","UEL0101","UAL0101"},
			
			T1TANK={"UEL0201","UAL0201","URL0107"},
			T2TANK={"URL0202","UAL0202","UEL0202"},
			SAB={"UAL0303","URL0303","UEL0303"},
			
			AMPHIBIOUSTANK={"UEL0203","URL0203"},
			
			INTERCEPTOR={"UAA0102","UEA0102","URA0102"},
			ASF={"UAA0303","UEA0303","URA0303"},
			
			T1SCOUT={"URA0101","UEA0101","UAA0101"},
			T3SCOUT={"UEA0302","UAA0302","URA0302"},
			
			T1BOMBER={"UEA0103","UAA0103","URA0103"},
			TORPEDOBOMBER={"URA0204","UAA0204","UEA0204"},
			T3BOMBER={"UEA0304","URA0304","UAA0304"},
			
			T2GUNSHIP={"URA0203","UAA0203","UEA0203"},
			T3GUNSHIP={"UEA0305"},
			
			MSG={"UAL0307","UEL0307"},
			MSS={"URL0306"},
			
			SOULRIPPER={"URA0401"},
			CZAR={"UAA0310"},
			ATLANTIS={"UES0401"},
			FATBOY={"UEL0401"},
			GC={"UAL0401"},
			MONKEYLORD={"URL0402"},
			SCATHIS={"URL0401"},
			TEMPEST={"UAS0401"},
			MAVOR={"UEB2401"},
			
			SCU={"UEL0301","UAL0301","URL0301"},
			
	}
	local IDTable = {}
	local IdsToRemove= {}
	for k, name in UnitNameTable do
		for i, v in nametable do
			local name1 = string.upper(v)
 			local name2 = string.gsub(name1, ' ', '') 
			local result = string.find(v,k)
			if result then
				local faction
				if string.find( v,'UEF') then
					faction = 'UE'
				elseif string.find( v,'AEON') then
					faction = 'UA'
				elseif string.find( v,'CYBRAN') then
					faction = 'UR'
				end
				for a, value in name do
					if string.find(v,faction) then
						table.insert(IDTable, value)
						--table.removeByValue(nametable,v)
					end
				end
			end
		end
	end
	local IDTable = table.merged(IDTable, nametable)
	return IDTable
end