local Prefs = import('/lua/user/prefs.lua')
local priwindow = import('/mods/TargetPriorityChanger/hook/lua/ui/game/PriorityList.lua')


local originalCreateUI = CreateUI

function CreateUI(isReplay)
	originalCreateUI(isReplay)
	local PriorityEdit = import('/mods/TargetPriorityChanger/hook/lua/ui/game/PriorityList.lua').CreateMainGroup()
	if not Prefs.GetFromCurrentProfile("saved_prioritiesv1") then
		defaultpriorities ={
				Default = { List={}, Default = true, Hotkey ='CTRL-D' },
			}
		Prefs.SetToCurrentProfile("saved_prioritiesv1", defaultpriorities)
	end
	HotkeyTable = {}
	for k, tables in Prefs.GetFromCurrentProfile("saved_prioritiesv1") do
		local hotkey = tables.Hotkey
		if hotkey and hotkey ~= '' then
			local name = k
			HotkeyTable[hotkey] = {}
			part1 = 'UI_Lua import("/mods/TargetPriorityChanger/hook/lua/ui/game/PriorityList.lua"'
			part2 =  ').HotkeyManager('.. '"' ..name..'"'..')'
			HotkeyTable[hotkey] = { action = part1..part2, stringkey = 'Priority Hotkey'}
		end
	end
	HotkeyTable["CTRL-Q"] = { action = 'UI_Lua import("/mods/TargetPriorityChanger/hook/lua/ui/game/PriorityList.lua").PriorityEditor()', stringkey = 'Priority Editor'}
	IN_AddKeyMapTable(HotkeyTable)
end


local originalOnSelectionChanged = OnSelectionChanged
local PriorityWindowOpen = false
local maxnumber = 0
local Priority = false

function OnSelectionChanged(oldSelection, newSelection, added, removed)
	priwindow.Toggle = 0
	priwindow.maxnumber = 0
	priwindow.Priority = false
	priwindow.Priorities = {}
	priwindow.Selection = table.copy(newSelection)
	CurrentSelection = newSelection
	
	if PriorityWindowOpen then
		priwindow.MiniPriorityList:Destroy()
		PriorityWindowOpen = false	
	end
	local oldHandleEvent = import('/lua/ui/game/gamemain.lua').GetGameParent().HandleEvent
	import('/lua/ui/game/gamemain.lua').GetGameParent().HandleEvent = function(self, event)
		if event.Type=="ButtonPress" and event.Modifiers.Middle then
			if PriorityWindowOpen then
				priwindow.MiniPriorityList:Destroy()
				PriorityWindowOpen = false	
			else
				if table.getn(CurrentSelection) > 0 then
					for k, unit in CurrentSelection do
						for k, weapon in unit:GetBlueprint().Weapon do
							if weapon.TargetPriorities and not PriorityWindowOpen then
								local army = GetFocusArmy()
								priwindow.MiniPriorityList = priwindow.PriorityList(import('/lua/ui/game/gamemain.lua').GetGameParent(),event.MouseX-95,event.MouseY+30,172,25,{},10,false)
								priwindow.MiniPriorityList.AddFields(Prefs.GetFromCurrentProfile("saved_prioritiesv1"))
								PriorityWindowOpen = true
							end
						end
					end
				end
			end
		end
		oldHandleEvent(self,event)
	end
    originalOnSelectionChanged(oldSelection, newSelection, added, removed)
end